//
//  920MHz LoRa/FSK RF module ES920LR3 
//  for Picossci (Raspberry Pi pico)
//


#include <Arduino.h>
#include "LoRa.h"

#define RX_pin 1
#define TX_pin 0

void LoRaReset(){
  pinMode(RX_pin, OUTPUT);
  pinMode(TX_pin, OUTPUT);
  digitalWrite(RX_pin, LOW);
  digitalWrite(TX_pin, LOW);
  delay(1000);
  pinMode(RX_pin, INPUT);
  pinMode(TX_pin, INPUT);
}


void LoRaConfigMode(){
  String rx;
  while(1){
    LoRaReset();
    Serial1.setTimeout(50);
    Serial1.begin(115200);
    delay(50);
    rx = Serial1.readString();
    Serial.println(rx);
    if (rx.indexOf("Select Mode [") >= 0) break;
    LoRaCommand("config");
    delay(100); 
  }
}


int LoRaCommand(String s){
  String rx;
  Serial1.print(s);
  Serial1.print("\r\n");
  Serial1.flush();
  Serial.println(s);
  Serial.flush();
  delay(10);
  rx = Serial1.readString();
  Serial.print(rx);
  return (rx.indexOf("OK"));
}


int LoRaInit(){
  LoRaConfigMode();
  if (LoRaCommand("2"     ) < 0) return(-1); // processor mode
  if (LoRaCommand("c 12"  ) < 0) return(-1); // spread factor
  if (LoRaCommand("d 3"   ) < 0) return(-1); // channel
  if (LoRaCommand("e 2345") < 0) return(-1); // PAN ID
  if (LoRaCommand("f 1"   ) < 0) return(-1); // own ID
  if (LoRaCommand("g ffff") < 0) return(-1); // broadcast
  if (LoRaCommand("z"     ) < 0) return(-1); // start
  return(0);
}
