//
//  Picossci (Raspberry Pi pico)
//  LM75B
//  920MHz LoRa/FSK RF module ES920LR3 
//  

#include "LoRa.h"
#include "pins_arduino.h"
 
#include <Wire.h>
#define LM75B_address 0x48          // A0=A1=A2=Low
#define temp_reg      0x00          //Temperture register


void setup(){
  Serial.begin(115200);
  Wire1.setSDA(D6);
  Wire1.setSCL(D7);
  Wire1.begin();
  Wire1.beginTransmission(LM75B_address);
  Wire1.write(temp_reg);
  Wire1.endTransmission();
  LoRaInit();
}


void loop(){
  signed int temp_data = 0;                    //LM75Bの温度レジスタの値用変数
  double temp = 0.0;                           //温度用変数
  Wire1.requestFrom(LM75B_address,2);           
  while(Wire1.available()){
    temp_data |= (Wire1.read() << 8);         //温度レジスタの上位8bit取得
    temp_data |= Wire1.read();                //温度レジスタの下位8bit取得(有効3bit)
  }
  temp = (temp_data >> 5) * 0.125;             //レジスタの値を温度情報に変換
 
  Serial.println(temp);
  LoRaCommand("MC"+String(temp));
  delay(5000);
}
 
